import { AxiosError, AxiosRequestConfig, AxiosResponse } from 'axios';
import { ResponseJson, HandlerFunction } from './types';
declare abstract class AxiosRouter<Data = {}> {
    abstract basePath: string;
    encript_query: boolean;
    private controllers;
    private use_mids;
    private global_mids;
    configs: AxiosRequestConfig;
    headers: AxiosRequestConfig["headers"];
    request?(_options: AxiosRequestConfig): Promise<AxiosRequestConfig | void>;
    response?(_res: AxiosResponse): Promise<AxiosResponse | void>;
    catchError?(err: AxiosError): void;
    private _path;
    private _configs;
    private excute;
    use(path: string | HandlerFunction, handler?: HandlerFunction, ...handlers: HandlerFunction[]): void;
    get(path: string, options?: AxiosRequestConfig): Promise<void | AxiosResponse<ResponseJson<Data>, any>>;
    post(path: string, options?: AxiosRequestConfig): Promise<void | AxiosResponse<ResponseJson<Data>, any>>;
    put(path: string, options?: AxiosRequestConfig): Promise<void | AxiosResponse<ResponseJson<Data>, any>>;
    del(path: string, options?: AxiosRequestConfig): Promise<void | AxiosResponse<ResponseJson<Data>, any>>;
    options(path: string, options?: AxiosRequestConfig): Promise<void | AxiosResponse<ResponseJson<Data>, any>>;
    patch(path: string, options?: AxiosRequestConfig): Promise<void | AxiosResponse<ResponseJson<Data>, any>>;
    abort(method: string, path: string): void;
    isFatching(method: string, path: string): boolean;
}
export default AxiosRouter;
