'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var axios = _interopDefault(require('axios'));
var AES = _interopDefault(require('crypto-js/aes'));
var Utf8 = _interopDefault(require('crypto-js/enc-utf8'));
var piece = require('json-piece');
var detectServer = require('detect-server');
var tinyUtils = require('tiny-utils');

function _asyncIterator(iterable) {
  var method,
      async,
      sync,
      retry = 2;

  for ("undefined" != typeof Symbol && (async = Symbol.asyncIterator, sync = Symbol.iterator); retry--;) {
    if (async && null != (method = iterable[async])) return method.call(iterable);
    if (sync && null != (method = iterable[sync])) return new AsyncFromSyncIterator(method.call(iterable));
    async = "@@asyncIterator", sync = "@@iterator";
  }

  throw new TypeError("Object is not async iterable");
}

function AsyncFromSyncIterator(s) {
  function AsyncFromSyncIteratorContinuation(r) {
    if (Object(r) !== r) return Promise.reject(new TypeError(r + " is not an object."));
    var done = r.done;
    return Promise.resolve(r.value).then(function (value) {
      return {
        value: value,
        done: done
      };
    });
  }

  return AsyncFromSyncIterator = function (s) {
    this.s = s, this.n = s.next;
  }, AsyncFromSyncIterator.prototype = {
    s: null,
    n: null,
    next: function () {
      return AsyncFromSyncIteratorContinuation(this.n.apply(this.s, arguments));
    },
    return: function (value) {
      var ret = this.s.return;
      return void 0 === ret ? Promise.resolve({
        value: value,
        done: !0
      }) : AsyncFromSyncIteratorContinuation(ret.apply(this.s, arguments));
    },
    throw: function (value) {
      var thr = this.s.return;
      return void 0 === thr ? Promise.reject(value) : AsyncFromSyncIteratorContinuation(thr.apply(this.s, arguments));
    }
  }, new AsyncFromSyncIterator(s);
}

function _regeneratorRuntime() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  _regeneratorRuntime = function () {
    return exports;
  };

  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) keys.push(key);

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

var ApiConfig = /*#__PURE__*/new Map(); // Default

if (!detectServer.isServer) {
  var _location, _location2;

  ApiConfig.set("encript", false);
  ApiConfig.set("guard", (_location = location) == null ? void 0 : _location.origin);
  ApiConfig.set("api_url", (_location2 = location) == null ? void 0 : _location2.origin);
}

var encript = function encript(data) {
  if (typeof data === 'object') data = piece.toString(data);
  return encodeURIComponent(AES.encrypt(data, ApiConfig.get("guard")).toString());
};
var decript = function decript(encriptVal) {
  var dec = AES.decrypt(decodeURIComponent(encriptVal), ApiConfig.get("guard")).toString(Utf8);
  if (piece.isStringfy(dec)) return piece.parse(dec);
  if (dec) return dec;
};

var key = "$soft.";
var stringfy = {
  toString: function toString(data) {
    var str = piece.toString(data);
    return "" + key + str;
  },
  isStringfy: function isStringfy(data) {
    if (data.startsWith(key)) {
      return piece.isStringfy(data.replace(key, ''));
    }

    return false;
  },
  parse: function parse(data) {
    if (data.startsWith(key)) {
      return piece.parse(data.replace(key, ''));
    }
  }
};

var AxiosRouter = /*#__PURE__*/function () {
  function AxiosRouter() {
    this.encript_query =  false ;
    this.controllers = {};
    this.use_mids = {};
    this.global_mids = [];
    this.configs = {};
    this.headers = {};
  }

  var _proto = AxiosRouter.prototype;

  _proto._path = function _path(path) {
    path = path.replace(/\/\//gi, '/');
    return ("" + (ApiConfig.get("api_url") + this.basePath) + path).replace(/\/$/, '');
  };

  _proto._configs = function _configs(path, options) {
    var _options$method;

    var abortController = new AbortController();
    this.controllers[path + (options == null ? void 0 : (_options$method = options.method) == null ? void 0 : _options$method.toLowerCase())] = abortController;
    return _extends({
      signal: abortController.signal,
      withCredentials: true,
      timeout: 5000
    }, this.configs, {
      headers: _extends({}, this.headers, this == null ? void 0 : this.configs.headers)
    }, options);
  };

  _proto.excute = /*#__PURE__*/function () {
    var _excute = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(path, options) {
      var _res$data;

      var use_mids, global_mids, middlewares, _iteratorAbruptCompletion, _didIteratorError, _iteratorError, _iterator, _step, middleware, configs, c, key, val, _key, _val, res, r;

      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (this.basePath) {
                _context.next = 2;
                break;
              }

              throw new Error("baseUri not found");

            case 2:
              path = this._path(path);
              use_mids = this.use_mids[path] || [];
              global_mids = this.global_mids || [];
              middlewares = [].concat(global_mids, use_mids);
              _context.prev = 6;
              _iteratorAbruptCompletion = false;
              _didIteratorError = false;
              _context.prev = 9;
              _iterator = _asyncIterator(middlewares);

            case 11:
              _context.next = 13;
              return _iterator.next();

            case 13:
              if (!(_iteratorAbruptCompletion = !(_step = _context.sent).done)) {
                _context.next = 20;
                break;
              }

              middleware = _step.value;
              _context.next = 17;
              return middleware(options);

            case 17:
              _iteratorAbruptCompletion = false;
              _context.next = 11;
              break;

            case 20:
              _context.next = 26;
              break;

            case 22:
              _context.prev = 22;
              _context.t0 = _context["catch"](9);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 26:
              _context.prev = 26;
              _context.prev = 27;

              if (!(_iteratorAbruptCompletion && _iterator["return"] != null)) {
                _context.next = 31;
                break;
              }

              _context.next = 31;
              return _iterator["return"]();

            case 31:
              _context.prev = 31;

              if (!_didIteratorError) {
                _context.next = 34;
                break;
              }

              throw _iteratorError;

            case 34:
              return _context.finish(31);

            case 35:
              return _context.finish(26);

            case 36:
              _context.next = 42;
              break;

            case 38:
              _context.prev = 38;
              _context.t1 = _context["catch"](6);
              delete this.controllers[path];
              throw _context.t1;

            case 42:
              configs = this._configs(path, options);
              configs.headers.map = location.origin;

              if (!this.request) {
                _context.next = 49;
                break;
              }

              _context.next = 47;
              return this.request(configs);

            case 47:
              c = _context.sent;

              if (c !== undefined) {
                configs = c;
              }

            case 49:
              if (Object.keys(configs.params || {}).length) {
                for (key in configs.params) {
                  val = configs.params[key];

                  if (val === null) {
                    configs.params[key] = "null";
                  } else if (tinyUtils.isObject(val) || tinyUtils.isArray(val)) {
                    configs.params[key] = stringfy.toString(val);
                  }
                }

                if (this.encript_query) {
                  configs.params = {
                    _: encript(configs.params)
                  };
                }
              }

              if (Object.keys(configs.data || {}).length) {
                for (_key in configs.data) {
                  _val = configs.data[_key];

                  if (tinyUtils.isObject(_val) || tinyUtils.isArray(_val)) {
                    configs.data[_key] = stringfy.toString(_val);
                  }
                }
              }

              _context.next = 53;
              return axios(_extends({
                url: path
              }, configs));

            case 53:
              res = _context.sent;

              if (typeof ((_res$data = res.data) == null ? void 0 : _res$data.data) === 'string') {
                res.data.data = decript(res.data.data);
              }

              if (!this.response) {
                _context.next = 60;
                break;
              }

              _context.next = 58;
              return this.response(res);

            case 58:
              r = _context.sent;

              if (r !== undefined) {
                res = r;
              }

            case 60:
              delete this.controllers[path];
              return _context.abrupt("return", res);

            case 62:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[6, 38], [9, 22, 26, 36], [27,, 31, 35]]);
    }));

    function excute(_x, _x2) {
      return _excute.apply(this, arguments);
    }

    return excute;
  }();

  _proto.use = function use(path, handler) {
    var handlersFN = [];

    if (handler) {
      handlersFN.push(handler);
    }

    for (var _len = arguments.length, handlers = new Array(_len > 2 ? _len - 2 : 0), _key2 = 2; _key2 < _len; _key2++) {
      handlers[_key2 - 2] = arguments[_key2];
    }

    if (handlers.length) {
      handlersFN = [].concat(handlersFN, handlers);
    }

    if (typeof path === 'string') {
      path = this._path(path);
      this.use_mids[path] = handlersFN;
    } else {
      this.global_mids = [].concat(this.global_mids, [path], handlersFN);
    }
  };

  _proto.get = /*#__PURE__*/function () {
    var _get = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(path, options) {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return this.excute(path, _extends({
                method: "get"
              }, options));

            case 3:
              return _context2.abrupt("return", _context2.sent);

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2["catch"](0);

              if (!this.catchError) {
                _context2.next = 12;
                break;
              }

              return _context2.abrupt("return", this.catchError(_context2.t0));

            case 12:
              throw _context2.t0;

            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this, [[0, 6]]);
    }));

    function get(_x3, _x4) {
      return _get.apply(this, arguments);
    }

    return get;
  }();

  _proto.post = /*#__PURE__*/function () {
    var _post = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(path, options) {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return this.excute(path, _extends({
                method: "post"
              }, options));

            case 3:
              return _context3.abrupt("return", _context3.sent);

            case 6:
              _context3.prev = 6;
              _context3.t0 = _context3["catch"](0);

              if (!this.catchError) {
                _context3.next = 12;
                break;
              }

              return _context3.abrupt("return", this.catchError(_context3.t0));

            case 12:
              throw _context3.t0;

            case 13:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this, [[0, 6]]);
    }));

    function post(_x5, _x6) {
      return _post.apply(this, arguments);
    }

    return post;
  }();

  _proto.put = /*#__PURE__*/function () {
    var _put = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(path, options) {
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.prev = 0;
              _context4.next = 3;
              return this.excute(path, _extends({
                method: "put"
              }, options));

            case 3:
              return _context4.abrupt("return", _context4.sent);

            case 6:
              _context4.prev = 6;
              _context4.t0 = _context4["catch"](0);

              if (!this.catchError) {
                _context4.next = 12;
                break;
              }

              return _context4.abrupt("return", this.catchError(_context4.t0));

            case 12:
              throw _context4.t0;

            case 13:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this, [[0, 6]]);
    }));

    function put(_x7, _x8) {
      return _put.apply(this, arguments);
    }

    return put;
  }();

  _proto.del = /*#__PURE__*/function () {
    var _del = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(path, options) {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.prev = 0;
              _context5.next = 3;
              return this.excute(path, _extends({
                method: "delete"
              }, options));

            case 3:
              return _context5.abrupt("return", _context5.sent);

            case 6:
              _context5.prev = 6;
              _context5.t0 = _context5["catch"](0);

              if (!this.catchError) {
                _context5.next = 12;
                break;
              }

              return _context5.abrupt("return", this.catchError(_context5.t0));

            case 12:
              throw _context5.t0;

            case 13:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this, [[0, 6]]);
    }));

    function del(_x9, _x10) {
      return _del.apply(this, arguments);
    }

    return del;
  }();

  _proto.options = /*#__PURE__*/function () {
    var _options2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(path, _options) {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              _context6.prev = 0;
              _context6.next = 3;
              return this.excute(path, _extends({
                method: "OPTIONS"
              }, _options));

            case 3:
              return _context6.abrupt("return", _context6.sent);

            case 6:
              _context6.prev = 6;
              _context6.t0 = _context6["catch"](0);

              if (!this.catchError) {
                _context6.next = 12;
                break;
              }

              return _context6.abrupt("return", this.catchError(_context6.t0));

            case 12:
              throw _context6.t0;

            case 13:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this, [[0, 6]]);
    }));

    function options(_x11, _x12) {
      return _options2.apply(this, arguments);
    }

    return options;
  }();

  _proto.patch = /*#__PURE__*/function () {
    var _patch = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(path, options) {
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              _context7.prev = 0;
              _context7.next = 3;
              return this.excute(path, _extends({
                method: "PATCH"
              }, options));

            case 3:
              return _context7.abrupt("return", _context7.sent);

            case 6:
              _context7.prev = 6;
              _context7.t0 = _context7["catch"](0);

              if (!this.catchError) {
                _context7.next = 12;
                break;
              }

              return _context7.abrupt("return", this.catchError(_context7.t0));

            case 12:
              throw _context7.t0;

            case 13:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this, [[0, 6]]);
    }));

    function patch(_x13, _x14) {
      return _patch.apply(this, arguments);
    }

    return patch;
  }();

  _proto.abort = function abort(method, path) {
    var controller = this.controllers[path + method.toLowerCase()];

    if (controller) {
      controller.abort();
    }
  };

  _proto.isFatching = function isFatching(method, path) {
    if (this.controllers[path + method.toLowerCase()]) {
      return true;
    }

    return false;
  };

  return AxiosRouter;
}();

var BaseRouter = /*#__PURE__*/function (_Router) {
  _inheritsLoose(BaseRouter, _Router);

  function BaseRouter() {
    return _Router.apply(this, arguments) || this;
  }

  var _proto = BaseRouter.prototype;

  _proto.catchError = function catchError(err) {
    var onFaild = ApiConfig.get("onFaild");

    if (typeof onFaild === 'function') {
      onFaild(err);
    } else {
      throw err;
    }
  };

  _proto.create = /*#__PURE__*/function () {
    var _create = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(data, options) {
      var _res$data;

      var res;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!this.beforeCreate) {
                _context.next = 4;
                break;
              }

              _context.next = 3;
              return this.beforeCreate(data);

            case 3:
              data = _context.sent;

            case 4:
              _context.next = 6;
              return this.post('/', _extends({}, options, {
                data: data
              }));

            case 6:
              res = _context.sent;

              if (!res) {
                _context.next = 9;
                break;
              }

              return _context.abrupt("return", (_res$data = res.data) == null ? void 0 : _res$data.data);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function create(_x, _x2) {
      return _create.apply(this, arguments);
    }

    return create;
  }();

  _proto.update = /*#__PURE__*/function () {
    var _update = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(data, where, options) {
      var _res$data2;

      var q, res;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!this.beforeUpdate) {
                _context2.next = 6;
                break;
              }

              _context2.next = 3;
              return this.beforeUpdate(data, where);

            case 3:
              q = _context2.sent;
              data = q.data;
              where = q.where;

            case 6:
              _context2.next = 8;
              return this.put('/', _extends({}, options, {
                data: data,
                params: where
              }));

            case 8:
              res = _context2.sent;
              return _context2.abrupt("return", res == null ? void 0 : (_res$data2 = res.data) == null ? void 0 : _res$data2.data);

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function update(_x3, _x4, _x5) {
      return _update.apply(this, arguments);
    }

    return update;
  }();

  _proto["delete"] = /*#__PURE__*/function () {
    var _delete2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(where, options) {
      var _res$data3;

      var res;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!this.beforeDelete) {
                _context3.next = 4;
                break;
              }

              _context3.next = 3;
              return this.beforeDelete(where);

            case 3:
              where = _context3.sent;

            case 4:
              _context3.next = 6;
              return this.del('/', _extends({}, options, {
                params: where
              }));

            case 6:
              res = _context3.sent;
              return _context3.abrupt("return", res == null ? void 0 : (_res$data3 = res.data) == null ? void 0 : _res$data3.data);

            case 8:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function _delete(_x6, _x7) {
      return _delete2.apply(this, arguments);
    }

    return _delete;
  }();

  _proto.find = /*#__PURE__*/function () {
    var _find = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(where, options) {
      var res;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (!this.beforeFind) {
                _context4.next = 4;
                break;
              }

              _context4.next = 3;
              return this.beforeFind(where);

            case 3:
              where = _context4.sent;

            case 4:
              _context4.next = 6;
              return this.get('/', _extends({}, options, {
                params: _extends({
                  perpage: 30
                }, where)
              }));

            case 6:
              res = _context4.sent;
              return _context4.abrupt("return", res == null ? void 0 : res.data.data);

            case 8:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function find(_x8, _x9) {
      return _find.apply(this, arguments);
    }

    return find;
  }();

  _proto.count = /*#__PURE__*/function () {
    var _count = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(where, options) {
      var res;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (!this.beforeCount) {
                _context5.next = 4;
                break;
              }

              _context5.next = 3;
              return this.beforeCount(where);

            case 3:
              where = _context5.sent;

            case 4:
              _context5.next = 6;
              return this.get('/count', _extends({}, options, {
                params: where
              }));

            case 6:
              res = _context5.sent;
              return _context5.abrupt("return", (res == null ? void 0 : res.data.data) || 0);

            case 8:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function count(_x10, _x11) {
      return _count.apply(this, arguments);
    }

    return count;
  }();

  return BaseRouter;
}(AxiosRouter);

(function (ApiTokenStatus) {
  ApiTokenStatus[ApiTokenStatus["active"] = 0] = "active";
  ApiTokenStatus[ApiTokenStatus["deactive"] = 1] = "deactive";
  ApiTokenStatus[ApiTokenStatus["trash"] = 2] = "trash";
})(exports.ApiTokenStatus || (exports.ApiTokenStatus = {}));

(function (UserRoleTypes) {
  UserRoleTypes[UserRoleTypes["admin"] = 0] = "admin";
  UserRoleTypes[UserRoleTypes["user"] = 1] = "user";
})(exports.UserRoleTypes || (exports.UserRoleTypes = {}));

(function (UserRoleStatus) {
  UserRoleStatus[UserRoleStatus["active"] = 0] = "active";
  UserRoleStatus[UserRoleStatus["deactive"] = 1] = "deactive";
  UserRoleStatus[UserRoleStatus["trash"] = 2] = "trash";
})(exports.UserRoleStatus || (exports.UserRoleStatus = {}));

(function (UserStatusTypes) {
  UserStatusTypes[UserStatusTypes["active"] = 0] = "active";
  UserStatusTypes[UserStatusTypes["deactive"] = 1] = "deactive";
  UserStatusTypes[UserStatusTypes["panding"] = 2] = "panding";
  UserStatusTypes[UserStatusTypes["trash"] = 3] = "trash";
})(exports.UserStatusTypes || (exports.UserStatusTypes = {}));

(function (PostStatusTypes) {
  PostStatusTypes[PostStatusTypes["publish"] = 0] = "publish";
  PostStatusTypes[PostStatusTypes["private"] = 1] = "private";
  PostStatusTypes[PostStatusTypes["protected"] = 2] = "protected";
  PostStatusTypes[PostStatusTypes["draft"] = 3] = "draft";
  PostStatusTypes[PostStatusTypes["trash"] = 4] = "trash";
})(exports.PostStatusTypes || (exports.PostStatusTypes = {}));

(function (PostCommentStatus) {
  PostCommentStatus[PostCommentStatus["public"] = 0] = "public";
  PostCommentStatus[PostCommentStatus["private"] = 1] = "private";
  PostCommentStatus[PostCommentStatus["trash"] = 2] = "trash";
})(exports.PostCommentStatus || (exports.PostCommentStatus = {}));

(function (MediaType) {
  MediaType[MediaType["unknown"] = 0] = "unknown";
  MediaType[MediaType["image"] = 1] = "image";
  MediaType[MediaType["audio"] = 2] = "audio";
  MediaType[MediaType["video"] = 3] = "video";
  MediaType[MediaType["archive"] = 4] = "archive";
  MediaType[MediaType["document"] = 5] = "document";
  MediaType[MediaType["pdf"] = 6] = "pdf";
})(exports.MediaType || (exports.MediaType = {}));

var AuthRoutes = /*#__PURE__*/function (_BaseRouter) {
  _inheritsLoose(AuthRoutes, _BaseRouter);

  function AuthRoutes() {
    var _this;

    _this = _BaseRouter.apply(this, arguments) || this;
    _this.basePath = "/auth";
    return _this;
  }

  var _proto = AuthRoutes.prototype;

  _proto.login = /*#__PURE__*/function () {
    var _login = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(username, password) {
      var _res$data;

      var res;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this.post('/login', {
                data: {
                  username: username,
                  password: password
                }
              });

            case 2:
              res = _context.sent;
              return _context.abrupt("return", (_res$data = res.data) == null ? void 0 : _res$data.data);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function login(_x, _x2) {
      return _login.apply(this, arguments);
    }

    return login;
  }();

  _proto.register = /*#__PURE__*/function () {
    var _register = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(email, password) {
      var _res$data2;

      var res;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this.post('/register', {
                data: {
                  email: email,
                  password: password
                }
              });

            case 2:
              res = _context2.sent;
              return _context2.abrupt("return", (_res$data2 = res.data) == null ? void 0 : _res$data2.data);

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function register(_x3, _x4) {
      return _register.apply(this, arguments);
    }

    return register;
  }();

  _proto.getAuth = /*#__PURE__*/function () {
    var _getAuth = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      var _res$data3;

      var res;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return this.get('/', {});

            case 2:
              res = _context3.sent;

              if (!res) {
                _context3.next = 5;
                break;
              }

              return _context3.abrupt("return", (_res$data3 = res.data) == null ? void 0 : _res$data3.data);

            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function getAuth() {
      return _getAuth.apply(this, arguments);
    }

    return getAuth;
  }();

  return AuthRoutes;
}(BaseRouter);

var Auth = /*#__PURE__*/new AuthRoutes();

var MediaRoutes = /*#__PURE__*/function (_BaseRouter) {
  _inheritsLoose(MediaRoutes, _BaseRouter);

  function MediaRoutes() {
    var _this;

    _this = _BaseRouter.apply(this, arguments) || this;
    _this.basePath = "/medias";
    _this.configs = {
      timeout: undefined,
      headers: {
        'Content-Type': 'multipart/form-data'
      }
    };
    return _this;
  }

  var _proto = MediaRoutes.prototype;

  _proto.beforeCreate = /*#__PURE__*/function () {
    var _beforeCreate = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(data) {
      var formData;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              formData = new FormData();
              formData.append('file', data.file);
              return _context.abrupt("return", formData);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    function beforeCreate(_x) {
      return _beforeCreate.apply(this, arguments);
    }

    return beforeCreate;
  }();

  return MediaRoutes;
}(BaseRouter);

var Media = /*#__PURE__*/new MediaRoutes();

var NotificationRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(NotificationRoutes, _Router);

  function NotificationRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/notifications";
    return _this;
  }

  return NotificationRoutes;
}(BaseRouter);

var Notification = /*#__PURE__*/new NotificationRoutes();

var OptionRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(OptionRoutes, _Router);

  function OptionRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/options";
    return _this;
  }

  return OptionRoutes;
}(BaseRouter);

var Option = /*#__PURE__*/new OptionRoutes();

var PostRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(PostRoutes, _Router);

  function PostRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/posts";
    return _this;
  }

  return PostRoutes;
}(BaseRouter);

var Post = /*#__PURE__*/new PostRoutes();

var PostCommentRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(PostCommentRoutes, _Router);

  function PostCommentRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/post-comments";
    return _this;
  }

  return PostCommentRoutes;
}(BaseRouter);

var PostComment = /*#__PURE__*/new PostCommentRoutes();

var PostMetaRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(PostMetaRoutes, _Router);

  function PostMetaRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/post-metas";
    return _this;
  }

  return PostMetaRoutes;
}(BaseRouter);

var PostMeta = /*#__PURE__*/new PostMetaRoutes();

var PostTermRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(PostTermRoutes, _Router);

  function PostTermRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/post-terms";
    return _this;
  }

  return PostTermRoutes;
}(BaseRouter);

var PostTerm = /*#__PURE__*/new PostTermRoutes();

var TermRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(TermRoutes, _Router);

  function TermRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/terms";
    return _this;
  }

  return TermRoutes;
}(BaseRouter);

var Term = /*#__PURE__*/new TermRoutes();

var TranslateRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(TranslateRoutes, _Router);

  function TranslateRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/translates";
    return _this;
  }

  return TranslateRoutes;
}(BaseRouter);

var Translate = /*#__PURE__*/new TranslateRoutes();

var UserRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(UserRoutes, _Router);

  function UserRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/users";
    return _this;
  }

  return UserRoutes;
}(BaseRouter);

var User = /*#__PURE__*/new UserRoutes();

var UserMetaRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(UserMetaRoutes, _Router);

  function UserMetaRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/user-metas";
    return _this;
  }

  return UserMetaRoutes;
}(BaseRouter);

var UserMeta = /*#__PURE__*/new UserMetaRoutes();

var UserRoleRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(UserRoleRoutes, _Router);

  function UserRoleRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/user-roles";
    return _this;
  }

  return UserRoleRoutes;
}(BaseRouter);

var UserRole = /*#__PURE__*/new UserRoleRoutes();

var VerificationRoutes = /*#__PURE__*/function (_Router) {
  _inheritsLoose(VerificationRoutes, _Router);

  function VerificationRoutes() {
    var _this;

    _this = _Router.apply(this, arguments) || this;
    _this.basePath = "/verifications";
    return _this;
  }

  return VerificationRoutes;
}(BaseRouter);

var Verification = /*#__PURE__*/new VerificationRoutes();

exports.ApiConfig = ApiConfig;
exports.AuthRouter = Auth;
exports.BaseRouter = BaseRouter;
exports.MediaRouter = Media;
exports.NotificationRouter = Notification;
exports.OptionRouter = Option;
exports.PostCommentRouter = PostComment;
exports.PostMetaRouter = PostMeta;
exports.PostRouter = Post;
exports.PostTermRouter = PostTerm;
exports.Router = AxiosRouter;
exports.TermRouter = Term;
exports.TranslateRouter = Translate;
exports.UserMetaRouter = UserMeta;
exports.UserRoleRouter = UserRole;
exports.UserRouter = User;
exports.VerificationRouter = Verification;
//# sourceMappingURL=nax-rest-api-client.cjs.development.js.map
