import BaseRouter from './BaseRouter';
import { BaseRouterArgs } from '../types';
import { User, UserRoleStatus } from '../types/Model';
export declare type AuthProps = Omit<User, 'password' | 'creator_id'> & {
    role: {
        name: string;
        type: UserRoleStatus;
        permissions: string;
    };
    photo: string;
};
interface Args extends BaseRouterArgs {
    responseData: AuthProps;
}
declare class AuthRoutes extends BaseRouter<Args> {
    basePath: string;
    login(username: string, password: string): Promise<{
        token: string;
        user: AuthProps;
    }>;
    register(email: string, password: string): Promise<User>;
    getAuth(): Promise<AuthProps | void>;
}
declare const _default: AuthRoutes;
export default _default;
