import { AxiosRequestConfig } from 'axios';
import Router from '../Router';
import { BaseRouterArgs } from '../types';
declare abstract class BaseRouter<Args extends BaseRouterArgs> extends Router<Args["model"]> {
    beforeCreate?(data: Args['data']): Promise<Args['data']>;
    beforeUpdate?(data: Args['data'], where: Args['where']): Promise<{
        data: Args['data'];
        where: Args['where'];
    }>;
    beforeDelete?(where: Args['where']): Promise<Args['where']>;
    beforeFind?(where: Args['where']): Promise<Args['where']>;
    beforeCount?(where: Args['where']): Promise<Args['where']>;
    catchError(err: any): void;
    create(data: Args['data'], options?: AxiosRequestConfig): Promise<Args['model'] | void>;
    update(data: Partial<Args['data']>, where: Args['where'], options?: AxiosRequestConfig): Promise<{
        count: number;
    }>;
    delete(where: Args['where'], options?: AxiosRequestConfig): Promise<{
        count: number;
    }>;
    find(where: Args['where'], options?: AxiosRequestConfig): Promise<Args['model'][] | null>;
    count(where: Args['where'], options?: AxiosRequestConfig): Promise<number>;
}
export default BaseRouter;
